% Compute the least squares error solution (1D)

clear
close all
clc

%% Generate data from ground truth model

ne  = 1000;
par = [2 1]';  % Parameters
snr = 3;       % Signal to noise ratio
beta = 3;      % Exponent of the power-law model

x = rand(ne,1);
y = par(1) + par(2)*x.^beta;
y = y + std(y)/snr*randn(size(y));

plot(x,y, '.');

%% Learn the model

Y = y;

X = [ones(ne,1) x];

par_ = inv(X'*X) * X' * Y

x1 = min(x):0.01:max(x);
hold on
plot(x1, par_(1) + par_(2) * x1, 'r', 'LineWidth',2); 