% Compute the least squares error solution (3D)

clear
close all
clc

%% Generate data from ground truth model

ne  = 1000;
par = [2 1 2 3]'
snr = 3;
beta = [1 1 1];  % Exponent of the power-law model

x = rand(ne,3);
y = par(1) + par(2)*x(:,1).^beta(1) + par(3)*x(:,2).^beta(2) + par(4)*x(:,3).^beta(3);
y = y + std(y)/snr*randn(size(y));

%% Learn the model

Y = y;
X = [ones(ne,1) x];

par_ = inv(X'*X) * X' * Y

